/*
 * Created on Nov 5, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.ibm.websphere.samples.bank.clients;

import java.rmi.RemoteException;
import java.util.Random;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import com.ibm.websphere.samples.bank.ejb.Account;
import com.ibm.websphere.samples.bank.ejb.AccountHome;
import com.ibm.websphere.samples.bank.ejb.Customer;
import com.ibm.websphere.samples.bank.ejb.CustomerHome;
import com.ibm.websphere.samples.bank.ejb.CustomerKey;

/**
 * @author IBMUser
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class CreateAccounts {

	private final static String CUSTOMER_JNDI_NAME = "java:comp/env/ejb/Customer";
	private final static String ACCOUNT_JNDI_NAME = "java:comp/env/ejb/Account";
	
	public static String [] lastNames =  {"Smith", "Jones", "Klein", "Mills", "Miller", "Johnson", "Simpson", "Anderson", "Lee", "Doe"};
	public static String [] firstNames =  {"John", "James", "Steve", "David", "Paul", "Jane", "Mary", "Catherine", "Linda", "Ann"};
	
	
	public static void main(String[] args) {
		
		System.out.println("WebSphereBank CreateAccounts >> -------------------- Begin --------------------");
		
		createCustomers(6);
		
		System.out.println("WebSphereBank CreateAccounts >> -------------------- Done  --------------------");
		
	}

	public static void createCustomers (int number) {
		Random r = new Random();
		r.setSeed(77);
		
		Context ctx = null;
		Object customerHomeObject = null;
		Object accountHomeObject = null;
		try {
			ctx = new InitialContext();
			customerHomeObject = ctx.lookup(CUSTOMER_JNDI_NAME);
			accountHomeObject = ctx.lookup(ACCOUNT_JNDI_NAME);
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		CustomerHome customerHome = (CustomerHome) javax.rmi.PortableRemoteObject.narrow(customerHomeObject, CustomerHome.class);
        AccountHome accountHome = (AccountHome) javax.rmi.PortableRemoteObject.narrow(accountHomeObject, AccountHome.class);
    
		for (int i = 1; i <= number; i++) {
		    try {
		    	// Create customer
				String lastName = lastNames[r.nextInt(lastNames.length - 1)];
				String firstName = firstNames[r.nextInt(firstNames.length - 1)];
				String taxID = "" + 11111*i;
				CustomerKey ckey = new CustomerKey((long) i);
				Customer cust = (Customer) customerHome.create(ckey, firstName, lastName, taxID);
				
				System.out.println("WebSphereBank CreateAccounts >> Create customer " + lastName + ", " + firstName + " " + i + " " + taxID);
				
				// Create Accounts
				Vector accounts = new Vector();
				
				// Savings account
			    int accountNumber = 100*i + 1;
			    int accountType = 1;
			    float balance = (float) (r.nextInt(15)*100.00);
			    Account account = (Account) accountHome.create(accountNumber, accountType, balance,(long) i);
			    accounts.add(account);
			    
			    System.out.println("WebSphereBank CreateAccounts >>      Create savings account " + accountNumber + ", $" + balance);
			    
			    //Checking account
			    accountNumber = 100*i;
			    accountType = 2;
			    balance = (float) (r.nextInt(20)*50.00);
			    account = (Account) accountHome.create(accountNumber, accountType, balance,(long) i);
			    accounts.add(account);
			    
			    System.out.println("WebSphereBank CreateAccounts >>      Create checking account " + accountNumber + ", $" + balance);
			    
			} catch (RemoteException e1) {
				e1.printStackTrace();
			} catch (CreateException e1) {
				e1.printStackTrace();
			}				
			
		}
	}
}
