//
// "This sample program is provided AS IS and may be used, executed, copied and modified without royalty payment by customer (a) for its own 
// instruction and study, (b) in order to develop applications designed to run with an IBM WebSphere product, either for customer's own internal use 
// or for redistribution by customer, as part of such an application, in customer's own products. " 
//
// Product 5724-I63,  (C) COPYRIGHT International Business Machines Corp., 2004
// All Rights Reserved * Licensed Materials - Property of IBM
//
package com.ibm.websphere.samples.bank.tags;

import javax.servlet.jsp.tagext.BodyTagSupport;
import java.util.HashMap;

import java.util.logging.*;

public class ContentTag extends BodyTagSupport {
    private String name;
    private String file;
    private String content;
    private boolean hasContent = true;

    static final String className = ContentTag.class.getName();
    private Logger messageLogger;
    private static final String rbName = null; // No localization is used for logging.

    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.IterationTag#doAfterBody()
     */
    public int doAfterBody() {
        if (hasContent) {
            TemplateTag parent = (TemplateTag) findAncestorWithClass(this, TemplateTag.class);
            HashMap h = parent.getTable();

            String bodyString = getBodyContent().getString();
            ContentItem ci = new ContentItem();
            ci.setContent(bodyString);

            h.put(name, ci);
        }

        return SKIP_BODY;
    }
    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag() {
        final String methodName = "doStartTag";
        try {
            messageLogger = Logger.getLogger(className, rbName);
        } catch (Exception e) {
            // Problem initializing logging.  Continue anyway.
        }

        if (!hasContent) {
            ContentItem ci = new ContentItem();
            ci.setFile(file);

            TemplateTag parent = (TemplateTag) findAncestorWithClass(this, TemplateTag.class);
            if (parent == null) {
                messageLogger.logp(Level.INFO, className, methodName, "No outer ancestor.");
            }
            HashMap h = parent.getTable();

            h.put(name, ci);
        }
        return EVAL_BODY_BUFFERED;
    }

    /**
     * @return String
     */
    public String getFile() {
        return file;
    }

    /**
     * @return String
     */
    public String getName() {
        return name;
    }

    /**
     * @param file
     */
    public void setFile(String file) {
        this.file = file;
        hasContent = false;
    }

    /**
     * @param name
     */
    public void setName(String name) {
        this.name = name;
    }
}
