//
// "This sample program is provided AS IS and may be used, executed, copied and modified without royalty payment by customer (a) for its own 
// instruction and study, (b) in order to develop applications designed to run with an IBM WebSphere product, either for customer's own internal use 
// or for redistribution by customer, as part of such an application, in customer's own products. " 
//
// Product 5724-I63,  (C) COPYRIGHT International Business Machines Corp., 2004
// All Rights Reserved * Licensed Materials - Property of IBM
//
package com.ibm.websphere.samples.bank.tags;

import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;
import java.util.HashMap;

import java.util.logging.*;

public class OutPutTag extends TagSupport {
    private String name;
    private String file;

    static final String className = OutPutTag.class.getName();
    private Logger messageLogger;
    private static final String rbName = null; // No localization is used for logging.

    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag() {
        final String methodName = "doStartTag";
        try {
            messageLogger = Logger.getLogger(className, rbName);
        } catch (Exception e) {
            // Problem initializing logging.  Continue anyway.
        }

        HashMap h = (HashMap) pageContext.getAttribute(TemplateTag.TEMPLATE_TABLE, PageContext.REQUEST_SCOPE);
        if (h == null) {
            messageLogger.logp(Level.INFO, className, methodName, "Exception getting hashtable.");
        }

        ContentItem ci = (ContentItem) h.get(name);
        if (ci == null) {
            if (file != null) {
                includeFile(file);
            }
        } else {
            if (ci.getHasContent()) {
                printContent(ci.getContent());
            } else {
                includeFile(ci.getFile());
            }
        }

        return SKIP_BODY;
    }
    /**
     * @param file
     */
    private void includeFile(String file) {
        final String methodName = "includeFile";
        try {
            messageLogger = Logger.getLogger(className, rbName);
        } catch (Exception e) {
            // Problem initializing logging.  Continue anyway.
        }

        try {
            pageContext.getOut().flush();
            pageContext.include(file);
        } catch (Exception e) {
            messageLogger.logp(Level.INFO, className, methodName, "Exception getting file: " + e);
        }
    }
    /**
     * @param content
     */
    private void printContent(String content) {
        final String methodName = "printContent";

        try {
            pageContext.getOut().flush();
            pageContext.getOut().print(content);
        } catch (Exception e) {
            messageLogger.logp(Level.INFO, className, methodName, "Exception displaying content: " + e);
        }
    }
    /**
     * @param file
     */
    public void setFile(String file) {
        this.file = file;
    }
    /**
     * @param name
     */
    public void setName(String name) {
        this.name = name;
    }
}
