//
// "This sample program is provided AS IS and may be used, executed, copied and modified without royalty payment by customer (a) for its own 
// instruction and study, (b) in order to develop applications designed to run with an IBM WebSphere product, either for customer's own internal use 
// or for redistribution by customer, as part of such an application, in customer's own products. " 
//
// Product 5724-I63,  (C) COPYRIGHT International Business Machines Corp., 2004
// All Rights Reserved * Licensed Materials - Property of IBM
//
package com.ibm.websphere.samples.bank.tags;

import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;
import java.util.HashMap;

import java.util.logging.*;

public class TemplateTag extends TagSupport {
    public static final String TEMPLATE_TABLE = "temptable";
    private String template;
    private HashMap table;

    static final String className = TemplateTag.class.getName();
    private Logger messageLogger;
    private static final String rbName = null; // No localization is used for logging.

    /**
     * @return HashMap
     */
    public HashMap getTable() {
        final String methodName = "getTable";
        try {
            messageLogger = Logger.getLogger(className, rbName);
       } catch (Exception e) {
            // Problem initializing logging.  Continue anyway.
        }

        table = (HashMap) pageContext.getAttribute(TEMPLATE_TABLE, PageContext.REQUEST_SCOPE);
        if (table == null) {
            messageLogger.logp(Level.INFO, className, methodName, TEMPLATE_TABLE + " not found");
            HashMap table = new HashMap();
            pageContext.setAttribute(TEMPLATE_TABLE, table, PageContext.REQUEST_SCOPE);
        }
        return table;
    }

    /**
     * @param template
     */
    public void setTemplate(String template) {
        this.template = template;
    }
    /**
     * @return String
     */
    public String getTemplate() {
        return template;
    }

    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag() {
        table = new HashMap();
        pageContext.setAttribute(TEMPLATE_TABLE, table, PageContext.REQUEST_SCOPE);
        return EVAL_BODY_INCLUDE;
    }

    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag() {
        final String methodName = "doEndTag";
        try {
            messageLogger = Logger.getLogger(className, rbName);
        } catch (Exception e) {
            // Problem initializing logging.  Continue anyway.
        }

        try {
            pageContext.include(template);
        } catch (Exception e) {
            messageLogger.logp(Level.INFO, className, methodName, "Exception in doEndTag: " + e);
        }
        return EVAL_PAGE;
    }
}
